%{!?ruby_sitelib:	%define ruby_sitelib	%(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")}
%{!?ruby_sitearch:	%define ruby_sitearch	%(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")}
%define		rubyabi		1.8

%define		modname		hpricot

Name:		ruby-%{modname}
Version:	0.6
Release:	2%{?dist}
Summary:	A Fast, Enjoyable HTML Parser for Ruby
Group:		Development/Languages

License:	MIT
URL:		http://code.whytheluckystiff.net/hpricot/
Source0:	http://code.whytheluckystiff.net/dist/%{modname}-%{version}.tgz
Patch0:		hpricot-0.6-skip-ragel-step-bz432186.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	ragel
BuildRequires:	ruby-devel
BuildRequires:	rubygem(rake)
BuildRequires:	ruby(abi) = %{rubyabi}
Requires:	ruby(abi) = %{rubyabi}
Provides:	ruby(%{modname}) = %{version}-%{release}

%description
Hpricot is a very flexible HTML parser, based on Tanaka Akira's 
HTree and John Resig's JQuery, but with the scanner recoded in C 
(using Ragel for scanning.)

%prep
%setup -q -n %{modname}-%{version}
%patch0 -p0 -b .ragel6

%build
# To make debuginfo work correctly...
pushd ext/hpricot_scan/
%{__mkdir_p} ext/hpricot_scan/
%{__cp} -p *.c *.rl ext/hpricot_scan/
popd

export CFLAGS="$RPM_OPT_FLAGS"
rake -v compile

%install
%{__rm} -rf $RPM_BUILD_ROOT

%{__mkdir_p} $RPM_BUILD_ROOT%{ruby_sitelib}/
%{__mkdir_p} $RPM_BUILD_ROOT%{ruby_sitearch}/

%{__cp} -pr lib/*/%{modname}*.so $RPM_BUILD_ROOT%{ruby_sitearch}/
%{__cp} -pr lib/%{modname}/ lib/%{modname}.rb \
	$RPM_BUILD_ROOT%{ruby_sitelib}/

for f in `find $RPM_BUILD_ROOT%{ruby_sitelib}/ -name \*.rb | sort` ; do
	%{__sed} -i -e '/^#!/d' $f
done

%check
rake test

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc CHANGELOG COPYING README

%{ruby_sitearch}/%{modname}*.so
%{ruby_sitelib}/%{modname}.rb
%{ruby_sitelib}/%{modname}/

%changelog
* Wed Feb 13 2008 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.6-2
- Rebuild against gcc43
- Patch for Rakefile to skip unneeded commands call for ragel 6.0+
  (bug 432186, Thanks Jeremy Hinegardner !!)

* Tue Nov  6 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.6-1
- 0.6

* Sat Nov  3 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.5.150-2
- Use rubygem(rake) for rebuild

* Fri Jun  8 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.5.150-1
- Initial packaging
